#ifndef SHADER_GL_H_
#define SHADER_GL_H_

#include "shader.h"

class ShaderGL : public Shader {
protected:
	/* bsz for vulkan, in opengl buf is 0 terminated */
	unsigned int sdr;
	virtual bool create(char *buf, unsigned int bsz, const char *fname);

public:
	ShaderGL();
	virtual ~ShaderGL();

	virtual void destroy() override;
	virtual void attach(unsigned int prog) override;
};

class ShaderProgramGL : public ShaderProgram {
protected:
	unsigned int prog;

public:
	ShaderProgramGL();
	virtual ~ShaderProgramGL();

	void destroy();
	void delete_shaders();
	virtual bool link() override;
	virtual bool load(const char *vfname, const char *ffname) override;
	virtual void use() override;
};

#endif // SHADER_GL_H_