/*
	Class Scene:
	It keeps the resources (materials, textures, meshes, lights, cameras).
	* loads resources
	* keeps pointers to them
	* performs the cleanup
*/

#ifndef SCENE_H_
#define SCENE_H_

#include <vector>

class Mesh;
struct Material;
class Texture;
class Object;

class Scene {
public:
	std::vector<Mesh *> meshes;
	std::vector<Material *> materials;
	std::vector<Texture *> textures;
	std::vector<Object *> objects;

	Scene();
	~Scene();

	bool load(const char *fname);
	//TODO
	// Texture *find_texture(const char *name);
	// Material *find_material(const char *name);
	// Mesh *find_mesh(const char *name);
};
#endif // SCENE_H_